using NUnit.Framework;
using WatiN.Core;

namespace adMoto.Payments.Test.UI
{
    [TestFixture]
    public class ValidationTests
    {
        private readonly UIHelper _uiHelper = new UIHelper();
        private static string adres = UIHelper.LoginSite;

        [Test]
        [Category("UI")]
        public void Validates_When_Firstname_Is_Too_Long()
        {
            var uiData = _uiHelper.CreateAndAddTestRecordToRepository(2);

            const string test = "test";

            var ie = new IE(adres);
            ie.TextField(Find.ByName("numerFaktury")).TypeText(uiData.Test_numer_faktury);
            ie.TextField(Find.ByName("nip")).TypeText(uiData.Test_nip);
            ie.Button(Find.ById("loguj")).Click();

            ie.TextField(Find.ByName("Payer.FirstName")).TypeText("12345678901234567890123456");
            ie.TextField(Find.ByName("Payer.LastName")).TypeText(test);
            ie.Button(Find.ById("place")).Click();
            Assert.IsTrue(ie.ContainsText("Zbyt długa nazwa"));
            _uiHelper.CloseWebBrowser(ie);

            //usuniecie rekordu z tabel: FAKTURY, FAKTURA_DETAILS
            _uiHelper.DeleteTestRecordsFromRepository(uiData);
        }

        [Test]
        [Category("UI")]
        public void Validates_When_Surname_Is_Too_Long()
        {
            var uiData = _uiHelper.CreateAndAddTestRecordToRepository(2);

            const string test = "test";

            var ie = new IE(adres);
            ie.TextField(Find.ByName("numerFaktury")).TypeText(uiData.Test_numer_faktury);
            ie.TextField(Find.ByName("nip")).TypeText(uiData.Test_nip);
            ie.Button(Find.ById("loguj")).Click();

            ie.TextField(Find.ByName("Payer.FirstName")).TypeText(test);
            ie.TextField(Find.ByName("Payer.LastName")).TypeText("1234567890123456789012345678901");
            ie.Button(Find.ById("place")).Click();
            Assert.IsTrue(ie.ContainsText("Zbyt długa nazwa"));
            _uiHelper.CloseWebBrowser(ie);

            //usuniecie rekordu z tabel: FAKTURY, FAKTURA_DETAILS
            _uiHelper.DeleteTestRecordsFromRepository(uiData);
        }

        [Test]
        [Category("UI")]
        public void Validates_When_LastName_Is_Empty()
        {
            var uiData = _uiHelper.CreateAndAddTestRecordToRepository(2);

            const string test = "test";

            var ie = new IE(adres);
            ie.TextField(Find.ByName("numerFaktury")).TypeText(uiData.Test_numer_faktury);
            ie.TextField(Find.ByName("nip")).TypeText(uiData.Test_nip);
            ie.Button(Find.ById("loguj")).Click();

            ie.TextField(Find.ByName("Payer.FirstName")).TypeText(test);
            ie.TextField(Find.ByName("Payer.LastName")).TypeText("");
            ie.Button(Find.ById("place")).Click();
            Assert.IsTrue(ie.ContainsText("Proszę podać"));
            _uiHelper.CloseWebBrowser(ie);

            //usuniecie rekordu z tabel: FAKTURY, FAKTURA_DETAILS
            _uiHelper.DeleteTestRecordsFromRepository(uiData);
        }
    }
}